require File.join(File.expand_path('../../../helpers', __FILE__),  "document_spec_helper")

describe "a tomte Document, regards Arrays" do


  class ArrayOuterDoc
    include Tomte::Document

     key :a, Array
     key :o, Object, :as_object => true
  end

  it 'should serialize documents inside arrays and be reversable' do

    i = ArrayOuterDoc.new(:a => [ MyDoc.new ], :o => [ MyDoc.new ])
    t = i.to_tomte

    r = Tomte::Document::Parser.load(t)

    expect(r.a).to be_a_kind_of Array
    expect(r.a.first).to  be_a_kind_of MyDoc

    expect(r.o).to be_a_kind_of Array
    expect(r.o.first).to  be_a_kind_of MyDoc
  end

  it 'should serialize documents inside arrays inside hashes and be reversable' do

    i = ArrayOuterDoc.new(:a => [ MyDoc.new ], :o => {:z => [MyDoc.new ]})
    t = i.to_tomte

    r = Tomte::Document::Parser.load(t)

    expect(r.o).to be_a_kind_of Hash
    expect(r.o[:z]).to be_a_kind_of Array
    expect(r.o[:z].first).to  be_a_kind_of MyDoc

  end

end


