require File.join(File.expand_path('../../../helpers', __FILE__),  "document_spec_helper")

describe "a tomte Document, containing another object which might be a document (or not)" do

  class ContainerDoc
    include Tomte::Document

     key :d, Object, :as_document => true
  end

  it 'should cast back documents to documents, if any' do
    i = ContainerDoc.new
    i.d = MyDoc.new(:foo => "hello world", :bar => 42)
    r = Tomte::Document::Parser.load(i.to_tomte)
    expect(r.d).to be_a_kind_of MyDoc
  end

  it 'should pass hashes-like objects unaltered' do
    i = ContainerDoc.new
    i.d = {:foo => "hello world", :bar => 42}
    r = Tomte::Document::Parser.load(i.to_tomte)
    expect(r.d).to be_a_kind_of Hash
  end

  it 'should pass other objects unaltered' do
    i = ContainerDoc.new
    i.d = "hello world"
    r = Tomte::Document::Parser.load(i.to_tomte)
    expect(r.d).to be_a_kind_of String
  end

  it 'should pass other objects unaltered' do
    i = ContainerDoc.new
    i.d = 8
    r = Tomte::Document::Parser.load(i.to_tomte)
    expect(r.d).to be_a_kind_of Integer
  end


  it 'would try cast hashes containing a :_doctype' do
    i = ContainerDoc.new
    i.d = {:foo => "hello world", :bar => 42 , :_doctype => "MyDoc"}
    r = Tomte::Document::Parser.load(i.to_tomte)
    expect(r.d).to be_a_kind_of MyDoc
  end
end
