require File.join(File.expand_path('../../../helpers', __FILE__),  "document_spec_helper")

describe "a serializable Document" do

  class OuterDoc
    include Tomte::Document

     key :inner, MyDoc
  end

  class OuterDocWithoutKeyType
    include Tomte::Document
  end

  before :each do
    @inner= MyDoc.new(:foo => "foo", :bar => "bar")
    @document = OuterDoc.new(:foo => "crap", :inner => @inner)
  end

  it 'should return the same object after being serialized into bson' do

    inner= MyDoc.new(:foo => "foo", :bar => "bar")
    document = OuterDoc.new(:foo => "crap", :inner => inner)

    b = document.to_bson
    new_doc = Tomte::Document::Parser.from_bson(b)
    expect(new_doc).to eq document
  end

  it 'should return the same object after being serialized into bson, even for when type is not declared' do

    inner= MyDoc.new(:foo => "foo", :bar => "bar")
    document = OuterDocWithoutKeyType.new(:foo => "crap", :inner => inner)

    b = document.to_bson
    new_doc = Tomte::Document::Parser.from_bson(b)
    expect(new_doc).to eq document
  end

end
