require File.join(File.expand_path('../../../helpers', __FILE__),  "document_spec_helper")

describe 'the Equality property' do

  before :each do
    @klass = Class.new do
       include Tomte::Document::Equality
    end
    @subklass = Class.new(@klass)

    @faker = Class.new do
      def initialize(faked)
        @faked = faked
      end

      def is_a?(klass)
        @faked.is_a? klass
      end
    end
  end

  it 'should work with regular instance' do
    expect(@klass === @klass.new).to be_truthy
  end

  it 'should work with instances of subclasses' do
    expect(@klass === @subklass.new ).to be_truthy
  end

  it 'should work with a faker class' do
    expect(@klass === @faker.new(@klass.new)).to be_truthy
  end

  it 'should not work with other instances' do
    expect(@klass === 1).not_to  be_truthy
  end

end