require File.join(File.expand_path('../../../helpers', __FILE__),  "document_spec_helper")

describe "a tomte Document, regards Hashes" do


  class OuterDoc
    include Tomte::Document

     key :h, Hash
     key :d, MyDoc
  end


  it 'should serialize documents inside hashes' do

    i = OuterDoc.new
    i.h = {:a =>  OuterDoc.new(:d => MyDoc.new)}

    t = i.to_tomte
    expect(t).to be_a_kind_of Hash
    expect(t[:h]).to be_a_kind_of Hash
    expect(t[:h][:a]).to be_a_kind_of Hash

  end

  it 'should serialize documents inside hashes and be reversable' do

    i = OuterDoc.new
    i.h = {:a =>  OuterDoc.new(:d => MyDoc.new)}

    t = i.to_tomte

    r = Tomte::Document::Parser.load(t)
    expect(r.h).to be_a_kind_of Hash
    expect(r.h[:a]).to  be_a_kind_of OuterDoc

  end


end


describe "a tomte OpenDocument, regards Hashes" do

  it 'should serialize documents inside hashes and be reversable' do
    d = Tomte::OpenDocument.new({:a =>1,
                                 :b => 2,
                                 :z => Tomte::OpenDocument.new( :a => Tomte::OpenDocument.new(:i => 4))})
    t = d.to_tomte
    r = Tomte::Document::Parser.load(t)
    expect(r.z).to be_a_kind_of Tomte::Document
    expect(r.z.a).to be_a_kind_of Tomte::Document

  end

  it 'should serialize documents inside hashes inside hashes and be reversable' do
    d = {:a => { :b => Tomte::OpenDocument.new(:i => 4) } }
    t = d.to_tomte
    r = Tomte::Document::Parser.load(t)
    expect(r[:a][:b]).to be_a_kind_of Tomte::Document

  end

end