require File.join(File.expand_path('../../../helpers', __FILE__),  "document_spec_helper")

describe 'a Document' do
  describe '#inspect' do

    before :each do
      @document = Doc('User') do
        key :name,  String
        key :age,   Integer
      end

      @doc = @document.new(:name => 'John', :age => 29)
    end

    it 'should print out attributes in alpha sorted order' do
      expect(@doc.inspect).to match(/ _doctype: "User", _id:.*, age: 29, name: "John"/)
    end

    it 'should include class name' do
      expect(@doc.inspect).to match(/^#<User/)
    end

  end
end