require File.join(File.expand_path('../../../helpers', __FILE__),  'document_spec_helper')

describe 'a Document' do
  describe '#new' do

    it 'with no id and _id of type integer' do
      expect {
        klass = Doc() do
          key :_id, Integer
        end
      }.not_to raise_error
    end


    it 'with no id and _id of type String' do
      expect {
        klass = Doc() do
          key :_id, String
        end
      }.not_to raise_error
    end

    it 'with no id and _id of type ObjectId' do
      expect {
        klass = Doc() do
          key :_id, Tomte::ObjectId
        end
      }.not_to raise_error
    end

  end


  # Address is an embedded document, um
  #
  #describe '.key?(:symbol)' do
  #  it 'should be true if document has key' do
  #    expect(Address.key?(:city)).to be_truthy
  #  end
  #
  #  it 'should be false if document does not have key' do
  #    expect()Address.key?(:foo)).to be_falsey
  #  end
  #end
  #
  #describe ".key?('string')" do
  #  it 'should be true if document has key' do
  #    Address.key?('city').should be_truthy
  #  end
  #
  #  it 'should be false if document does not have key' do
  #    Address.key?('foo').should be_falsey
  #  end
  #end


  describe '.new (from data)' do
    before :each do
      @klass = Doc do
        key :user, Hash

        def user=(user)
          super(:id => user.id, :name => user.name)
        end
      end

      user_class = Struct.new(:id, :name)
      @doc = @klass.new(:user => user_class.new(1, 'Foo Bar'))
    end

    it 'should use []= for keys instead of public writer' do
      expect {
        expect(@doc.user['id']).to eq 1
        expect(@doc.user['name']).to eq 'Foo Bar'
      }.not_to raise_error
    end
  end

  describe '.load' do
    it 'should return nil if argument is nil' do
      expect(Doc().load(nil)).to be_nil
    end
  end


end